package org.example;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.Scanner;

public class ClientWindow extends JFrame {

    private byte[] lenpack = new byte[1024];

    private JTextField jtfMessage;
    private JTextField jtfName;
    private JTextArea jtaTextAreaMessage;
    private String clientName = "";

    public ClientWindow() throws IOException {

        setBounds(600, 300, 600, 500);
        setTitle("UDP_Chat");
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        jtaTextAreaMessage = new JTextArea();
        jtaTextAreaMessage.setEditable(false);
        jtaTextAreaMessage.setLineWrap(true);
        JScrollPane jsp = new JScrollPane(jtaTextAreaMessage);
        add(jsp, BorderLayout.CENTER);
        JPanel bottomPanel = new JPanel(new BorderLayout());
        add(bottomPanel, BorderLayout.SOUTH);
        JButton jbSendMessage = new JButton("Отправить");
        bottomPanel.add(jbSendMessage, BorderLayout.EAST);
        jtfMessage = new JTextField("Введите ваше сообщение: ");
        bottomPanel.add(jtfMessage, BorderLayout.CENTER);
        jtfName = new JTextField("Введите ваше имя: ");
        bottomPanel.add(jtfName, BorderLayout.WEST);
        MulticastSocket socket = new MulticastSocket(4321);
        InetAddress group = InetAddress.getByName("230.0.0.0");
        socket.joinGroup(group);
        jbSendMessage.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                if (!jtfMessage.getText().trim().isEmpty() && !jtfName.getText().trim().isEmpty()) {
                    clientName = jtfName.getText();
                    try {
                        sendMsg();
                    } catch (IOException ex) {
                        throw new RuntimeException(ex);
                    }

                    jtfMessage.grabFocus();
                }
            }
        });

        jtfMessage.addFocusListener(new FocusAdapter() {
            @Override
            public void focusGained(FocusEvent e) {
                jtfMessage.setText("");
            }
        });

        jtfName.addFocusListener(new FocusAdapter() {
            @Override
            public void focusGained(FocusEvent e) {
                jtfName.setText("");
            }
        });
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {

                    while (true) {

                        DatagramPacket packet = new DatagramPacket(lenpack, lenpack.length);
                        socket.receive(packet);
                        String msg = new String(packet.getData(), packet.getOffset(), packet.getLength());
                        jtaTextAreaMessage.append(msg);
                        jtaTextAreaMessage.append("\n");

                    }
                } catch (IOException ex) {
                    throw new RuntimeException(ex);
                }
            }

        }).start();


        setVisible(true);

    }

    public void sendMsg() throws IOException {

        String messageStr = jtfName.getText() + ": " + jtfMessage.getText();

        DatagramSocket socket2 = new DatagramSocket();
        InetAddress group = InetAddress.getByName("230.0.0.0");
        byte[] msg = messageStr.getBytes();
        DatagramPacket packet = new DatagramPacket(msg, msg.length, group, 4321);
        socket2.send(packet);
        socket2.close();

        jtfMessage.setText("");
    }
}

